maint.mk 61 KB

1234567891011121314151617181920212223242526272829303132333435363738394041424344454647484950515253545556575859606162636465666768697071727374757677787980818283848586878889909192939495969798991001011021031041051061071081091101111121131141151161171181191201211221231241251261271281291301311321331341351361371381391401411421431441451461471481491501511521531541551561571581591601611621631641651661671681691701711721731741751761771781791801811821831841851861871881891901911921931941951961971981992002012022032042052062072082092102112122132142152162172182192202212222232242252262272282292302312322332342352362372382392402412422432442452462472482492502512522532542552562572582592602612622632642652662672682692702712722732742752762772782792802812822832842852862872882892902912922932942952962972982993003013023033043053063073083093103113123133143153163173183193203213223233243253263273283293303313323333343353363373383393403413423433443453463473483493503513523533543553563573583593603613623633643653663673683693703713723733743753763773783793803813823833843853863873883893903913923933943953963973983994004014024034044054064074084094104114124134144154164174184194204214224234244254264274284294304314324334344354364374384394404414424434444454464474484494504514524534544554564574584594604614624634644654664674684694704714724734744754764774784794804814824834844854864874884894904914924934944954964974984995005015025035045055065075085095105115125135145155165175185195205215225235245255265275285295305315325335345355365375385395405415425435445455465475485495505515525535545555565575585595605615625635645655665675685695705715725735745755765775785795805815825835845855865875885895905915925935945955965975985996006016026036046056066076086096106116126136146156166176186196206216226236246256266276286296306316326336346356366376386396406416426436446456466476486496506516526536546556566576586596606616626636646656666676686696706716726736746756766776786796806816826836846856866876886896906916926936946956966976986997007017027037047057067077087097107117127137147157167177187197207217227237247257267277287297307317327337347357367377387397407417427437447457467477487497507517527537547557567577587597607617627637647657667677687697707717727737747757767777787797807817827837847857867877887897907917927937947957967977987998008018028038048058068078088098108118128138148158168178188198208218228238248258268278288298308318328338348358368378388398408418428438448458468478488498508518528538548558568578588598608618628638648658668678688698708718728738748758768778788798808818828838848858868878888898908918928938948958968978988999009019029039049059069079089099109119129139149159169179189199209219229239249259269279289299309319329339349359369379389399409419429439449459469479489499509519529539549559569579589599609619629639649659669679689699709719729739749759769779789799809819829839849859869879889899909919929939949959969979989991000100110021003100410051006100710081009101010111012101310141015101610171018101910201021102210231024102510261027102810291030103110321033103410351036103710381039104010411042104310441045104610471048104910501051105210531054105510561057105810591060106110621063106410651066106710681069107010711072107310741075107610771078107910801081108210831084108510861087108810891090109110921093109410951096109710981099110011011102110311041105110611071108110911101111111211131114111511161117111811191120112111221123112411251126112711281129113011311132113311341135113611371138113911401141114211431144114511461147114811491150115111521153115411551156115711581159116011611162116311641165116611671168116911701171117211731174117511761177117811791180118111821183118411851186118711881189119011911192119311941195119611971198119912001201120212031204120512061207120812091210121112121213121412151216121712181219122012211222122312241225122612271228122912301231123212331234123512361237123812391240124112421243124412451246124712481249125012511252125312541255125612571258125912601261126212631264126512661267126812691270127112721273127412751276127712781279128012811282128312841285128612871288128912901291129212931294129512961297129812991300130113021303130413051306130713081309131013111312131313141315131613171318131913201321132213231324132513261327132813291330133113321333133413351336133713381339134013411342134313441345134613471348134913501351135213531354135513561357135813591360136113621363136413651366136713681369137013711372137313741375137613771378137913801381138213831384138513861387138813891390139113921393139413951396139713981399140014011402140314041405140614071408140914101411141214131414141514161417141814191420142114221423142414251426142714281429143014311432143314341435143614371438143914401441144214431444144514461447144814491450145114521453145414551456145714581459146014611462146314641465146614671468146914701471147214731474147514761477147814791480148114821483148414851486148714881489149014911492149314941495149614971498149915001501150215031504150515061507150815091510151115121513151415151516151715181519152015211522152315241525152615271528152915301531153215331534153515361537153815391540154115421543154415451546154715481549155015511552155315541555155615571558155915601561156215631564156515661567156815691570157115721573157415751576157715781579158015811582158315841585158615871588158915901591159215931594159515961597159815991600160116021603160416051606160716081609161016111612161316141615161616171618161916201621162216231624162516261627162816291630163116321633163416351636163716381639164016411642164316441645164616471648164916501651165216531654
  1. # -*-Makefile-*-
  2. # This Makefile fragment tries to be general-purpose enough to be
  3. # used by many projects via the gnulib maintainer-makefile module.
  4. ## Copyright (C) 2001-2012 Free Software Foundation, Inc.
  5. ##
  6. ## This program is free software: you can redistribute it and/or modify
  7. ## it under the terms of the GNU General Public License as published by
  8. ## the Free Software Foundation, either version 3 of the License, or
  9. ## (at your option) any later version.
  10. ##
  11. ## This program is distributed in the hope that it will be useful,
  12. ## but WITHOUT ANY WARRANTY; without even the implied warranty of
  13. ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  14. ## GNU General Public License for more details.
  15. ##
  16. ## You should have received a copy of the GNU General Public License
  17. ## along with this program. If not, see <http://www.gnu.org/licenses/>.
  18. # This is reported not to work with make-3.79.1
  19. # ME := $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))
  20. ME := maint.mk
  21. # Diagnostic for continued use of deprecated variable.
  22. # Remove in 2013
  23. ifneq ($(build_aux),)
  24. $(error "$(ME): \
  25. set $$(_build-aux) relative to $$(srcdir) instead of $$(build_aux)")
  26. endif
  27. # Helper variables.
  28. _empty =
  29. _sp = $(_empty) $(_empty)
  30. # _equal,S1,S2
  31. # ------------
  32. # If S1 == S2, return S1, otherwise the empty string.
  33. _equal = $(and $(findstring $(1),$(2)),$(findstring $(2),$(1)))
  34. # member-check,VARIABLE,VALID-VALUES
  35. # ----------------------------------
  36. # Check that $(VARIABLE) is in the space-separated list of VALID-VALUES, and
  37. # return it. Die otherwise.
  38. member-check = \
  39. $(strip \
  40. $(if $($(1)), \
  41. $(if $(findstring $(_sp),$($(1))), \
  42. $(error invalid $(1): '$($(1))', expected $(2)), \
  43. $(or $(findstring $(_sp)$($(1))$(_sp),$(_sp)$(2)$(_sp)), \
  44. $(error invalid $(1): '$($(1))', expected $(2)))), \
  45. $(error $(1) undefined)))
  46. # Do not save the original name or timestamp in the .tar.gz file.
  47. # Use --rsyncable if available.
  48. gzip_rsyncable := \
  49. $(shell gzip --help 2>/dev/null|grep rsyncable >/dev/null \
  50. && printf %s --rsyncable)
  51. GZIP_ENV = '--no-name --best $(gzip_rsyncable)'
  52. GIT = git
  53. VC = $(GIT)
  54. VC_LIST = $(srcdir)/$(_build-aux)/vc-list-files -C $(srcdir)
  55. # You can override this variable in cfg.mk to set your own regexp
  56. # matching files to ignore.
  57. VC_LIST_ALWAYS_EXCLUDE_REGEX ?= ^$$
  58. # This is to preprocess robustly the output of $(VC_LIST), so that even
  59. # when $(srcdir) is a pathological name like "....", the leading sed command
  60. # removes only the intended prefix.
  61. _dot_escaped_srcdir = $(subst .,\.,$(srcdir))
  62. # Post-process $(VC_LIST) output, prepending $(srcdir)/, but only
  63. # when $(srcdir) is not ".".
  64. ifeq ($(srcdir),.)
  65. _prepend_srcdir_prefix =
  66. else
  67. _prepend_srcdir_prefix = | sed 's|^|$(srcdir)/|'
  68. endif
  69. # In order to be able to consistently filter "."-relative names,
  70. # (i.e., with no $(srcdir) prefix), this definition is careful to
  71. # remove any $(srcdir) prefix, and to restore what it removes.
  72. _sc_excl = \
  73. $(or $(exclude_file_name_regexp--$@),^$$)
  74. VC_LIST_EXCEPT = \
  75. $(VC_LIST) | sed 's|^$(_dot_escaped_srcdir)/||' \
  76. | if test -f $(srcdir)/.x-$@; then grep -vEf $(srcdir)/.x-$@; \
  77. else grep -Ev -e "$${VC_LIST_EXCEPT_DEFAULT-ChangeLog}"; fi \
  78. | grep -Ev -e '($(VC_LIST_ALWAYS_EXCLUDE_REGEX)|$(_sc_excl))' \
  79. $(_prepend_srcdir_prefix)
  80. ifeq ($(origin prev_version_file), undefined)
  81. prev_version_file = $(srcdir)/.prev-version
  82. endif
  83. PREV_VERSION := $(shell cat $(prev_version_file) 2>/dev/null)
  84. VERSION_REGEXP = $(subst .,\.,$(VERSION))
  85. PREV_VERSION_REGEXP = $(subst .,\.,$(PREV_VERSION))
  86. ifeq ($(VC),$(GIT))
  87. this-vc-tag = v$(VERSION)
  88. this-vc-tag-regexp = v$(VERSION_REGEXP)
  89. else
  90. tag-package = $(shell echo "$(PACKAGE)" | tr '[:lower:]' '[:upper:]')
  91. tag-this-version = $(subst .,_,$(VERSION))
  92. this-vc-tag = $(tag-package)-$(tag-this-version)
  93. this-vc-tag-regexp = $(this-vc-tag)
  94. endif
  95. my_distdir = $(PACKAGE)-$(VERSION)
  96. # Old releases are stored here.
  97. release_archive_dir ?= ../release
  98. # If RELEASE_TYPE is undefined, but RELEASE is, use its second word.
  99. # But overwrite VERSION.
  100. ifdef RELEASE
  101. VERSION := $(word 1, $(RELEASE))
  102. RELEASE_TYPE ?= $(word 2, $(RELEASE))
  103. endif
  104. # Validate and return $(RELEASE_TYPE), or die.
  105. RELEASE_TYPES = alpha beta stable
  106. release-type = $(call member-check,RELEASE_TYPE,$(RELEASE_TYPES))
  107. # Override gnu_rel_host and url_dir_list in cfg.mk if these are not right.
  108. # Use alpha.gnu.org for alpha and beta releases.
  109. # Use ftp.gnu.org for stable releases.
  110. gnu_ftp_host-alpha = alpha.gnu.org
  111. gnu_ftp_host-beta = alpha.gnu.org
  112. gnu_ftp_host-stable = ftp.gnu.org
  113. gnu_rel_host ?= $(gnu_ftp_host-$(release-type))
  114. url_dir_list ?= $(if $(call _equal,$(gnu_rel_host),ftp.gnu.org), \
  115. http://ftpmirror.gnu.org/$(PACKAGE), \
  116. ftp://$(gnu_rel_host)/gnu/$(PACKAGE))
  117. # Override this in cfg.mk if you are using a different format in your
  118. # NEWS file.
  119. today = $(shell date +%Y-%m-%d)
  120. # Select which lines of NEWS are searched for $(news-check-regexp).
  121. # This is a sed line number spec. The default says that we search
  122. # lines 1..10 of NEWS for $(news-check-regexp).
  123. # If you want to search only line 3 or only lines 20-22, use "3" or "20,22".
  124. news-check-lines-spec ?= 1,10
  125. news-check-regexp ?= '^\*.* $(VERSION_REGEXP) \($(today)\)'
  126. # Prevent programs like 'sort' from considering distinct strings to be equal.
  127. # Doing it here saves us from having to set LC_ALL elsewhere in this file.
  128. export LC_ALL = C
  129. ## --------------- ##
  130. ## Sanity checks. ##
  131. ## --------------- ##
  132. _cfg_mk := $(shell test -f $(srcdir)/cfg.mk && echo '$(srcdir)/cfg.mk')
  133. # Collect the names of rules starting with 'sc_'.
  134. syntax-check-rules := $(sort $(shell sed -n 's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p' \
  135. $(srcdir)/$(ME) $(_cfg_mk)))
  136. .PHONY: $(syntax-check-rules)
  137. ifeq ($(shell $(VC_LIST) >/dev/null 2>&1; echo $$?),0)
  138. local-checks-available += $(syntax-check-rules)
  139. else
  140. local-checks-available += no-vc-detected
  141. no-vc-detected:
  142. @echo "No version control files detected; skipping syntax check"
  143. endif
  144. .PHONY: $(local-checks-available)
  145. # Arrange to print the name of each syntax-checking rule just before running it.
  146. $(syntax-check-rules): %: %.m
  147. sc_m_rules_ = $(patsubst %, %.m, $(syntax-check-rules))
  148. .PHONY: $(sc_m_rules_)
  149. $(sc_m_rules_):
  150. @echo $(patsubst sc_%.m, %, $@)
  151. @date +%s.%N > .sc-start-$(basename $@)
  152. # Compute and print the elapsed time for each syntax-check rule.
  153. sc_z_rules_ = $(patsubst %, %.z, $(syntax-check-rules))
  154. .PHONY: $(sc_z_rules_)
  155. $(sc_z_rules_): %.z: %
  156. @end=$$(date +%s.%N); \
  157. start=$$(cat .sc-start-$*); \
  158. rm -f .sc-start-$*; \
  159. awk -v s=$$start -v e=$$end \
  160. 'END {printf "%.2f $(patsubst sc_%,%,$*)\n", e - s}' < /dev/null
  161. # The patsubst here is to replace each sc_% rule with its sc_%.z wrapper
  162. # that computes and prints elapsed time.
  163. local-check := \
  164. $(patsubst sc_%, sc_%.z, \
  165. $(filter-out $(local-checks-to-skip), $(local-checks-available)))
  166. syntax-check: $(local-check)
  167. # _sc_search_regexp
  168. #
  169. # This macro searches for a given construct in the selected files and
  170. # then takes some action.
  171. #
  172. # Parameters (shell variables):
  173. #
  174. # prohibit | require
  175. #
  176. # Regular expression (ERE) denoting either a forbidden construct
  177. # or a required construct. Those arguments are exclusive.
  178. #
  179. # exclude
  180. #
  181. # Regular expression (ERE) denoting lines to ignore that matched
  182. # a prohibit construct. For example, this can be used to exclude
  183. # comments that mention why the nearby code uses an alternative
  184. # construct instead of the simpler prohibited construct.
  185. #
  186. # in_vc_files | in_files
  187. #
  188. # grep-E-style regexp selecting the files to check. For in_vc_files,
  189. # the regexp is used to select matching files from the list of all
  190. # version-controlled files; for in_files, it's from the names printed
  191. # by "find $(srcdir)". When neither is specified, use all files that
  192. # are under version control.
  193. #
  194. # containing | non_containing
  195. #
  196. # Select the files (non) containing strings matching this regexp.
  197. # If both arguments are specified then CONTAINING takes
  198. # precedence.
  199. #
  200. # with_grep_options
  201. #
  202. # Extra options for grep.
  203. #
  204. # ignore_case
  205. #
  206. # Ignore case.
  207. #
  208. # halt
  209. #
  210. # Message to display before to halting execution.
  211. #
  212. # Finally, you may exempt files based on an ERE matching file names.
  213. # For example, to exempt from the sc_space_tab check all files with the
  214. # .diff suffix, set this Make variable:
  215. #
  216. # exclude_file_name_regexp--sc_space_tab = \.diff$
  217. #
  218. # Note that while this functionality is mostly inherited via VC_LIST_EXCEPT,
  219. # when filtering by name via in_files, we explicitly filter out matching
  220. # names here as well.
  221. # Initialize each, so that envvar settings cannot interfere.
  222. export require =
  223. export prohibit =
  224. export exclude =
  225. export in_vc_files =
  226. export in_files =
  227. export containing =
  228. export non_containing =
  229. export halt =
  230. export with_grep_options =
  231. # By default, _sc_search_regexp does not ignore case.
  232. export ignore_case =
  233. _ignore_case = $$(test -n "$$ignore_case" && printf %s -i || :)
  234. define _sc_say_and_exit
  235. dummy=; : so we do not need a semicolon before each use; \
  236. { printf '%s\n' "$(ME): $$msg" 1>&2; exit 1; };
  237. endef
  238. define _sc_search_regexp
  239. dummy=; : so we do not need a semicolon before each use; \
  240. \
  241. : Check arguments; \
  242. test -n "$$prohibit" && test -n "$$require" \
  243. && { msg='Cannot specify both prohibit and require' \
  244. $(_sc_say_and_exit) } || :; \
  245. test -z "$$prohibit" && test -z "$$require" \
  246. && { msg='Should specify either prohibit or require' \
  247. $(_sc_say_and_exit) } || :; \
  248. test -z "$$prohibit" && test -n "$$exclude" \
  249. && { msg='Use of exclude requires a prohibit pattern' \
  250. $(_sc_say_and_exit) } || :; \
  251. test -n "$$in_vc_files" && test -n "$$in_files" \
  252. && { msg='Cannot specify both in_vc_files and in_files' \
  253. $(_sc_say_and_exit) } || :; \
  254. test "x$$halt" != x \
  255. || { msg='halt not defined' $(_sc_say_and_exit) }; \
  256. \
  257. : Filter by file name; \
  258. if test -n "$$in_files"; then \
  259. files=$$(find $(srcdir) | grep -E "$$in_files" \
  260. | grep -Ev '$(_sc_excl)'); \
  261. else \
  262. files=$$($(VC_LIST_EXCEPT)); \
  263. if test -n "$$in_vc_files"; then \
  264. files=$$(echo "$$files" | grep -E "$$in_vc_files"); \
  265. fi; \
  266. fi; \
  267. \
  268. : Filter by content; \
  269. test -n "$$files" && test -n "$$containing" \
  270. && { files=$$(grep -l "$$containing" $$files); } || :; \
  271. test -n "$$files" && test -n "$$non_containing" \
  272. && { files=$$(grep -vl "$$non_containing" $$files); } || :; \
  273. \
  274. : Check for the construct; \
  275. if test -n "$$files"; then \
  276. if test -n "$$prohibit"; then \
  277. grep $$with_grep_options $(_ignore_case) -nE "$$prohibit" $$files \
  278. | grep -vE "$${exclude:-^$$}" \
  279. && { msg="$$halt" $(_sc_say_and_exit) } || :; \
  280. else \
  281. grep $$with_grep_options $(_ignore_case) -LE "$$require" $$files \
  282. | grep . \
  283. && { msg="$$halt" $(_sc_say_and_exit) } || :; \
  284. fi \
  285. else :; \
  286. fi || :;
  287. endef
  288. sc_avoid_if_before_free:
  289. @$(srcdir)/$(_build-aux)/useless-if-before-free \
  290. $(useless_free_options) \
  291. $$($(VC_LIST_EXCEPT) | grep -v useless-if-before-free) && \
  292. { echo '$(ME): found useless "if" before "free" above' 1>&2; \
  293. exit 1; } || :
  294. sc_cast_of_argument_to_free:
  295. @prohibit='\<free *\( *\(' halt="don't cast free argument" \
  296. $(_sc_search_regexp)
  297. sc_cast_of_x_alloc_return_value:
  298. @prohibit='\*\) *x(m|c|re)alloc\>' \
  299. halt="don't cast x*alloc return value" \
  300. $(_sc_search_regexp)
  301. sc_cast_of_alloca_return_value:
  302. @prohibit='\*\) *alloca\>' \
  303. halt="don't cast alloca return value" \
  304. $(_sc_search_regexp)
  305. sc_space_tab:
  306. @prohibit='[ ] ' \
  307. halt='found SPACE-TAB sequence; remove the SPACE' \
  308. $(_sc_search_regexp)
  309. # Don't use *scanf or the old ato* functions in "real" code.
  310. # They provide no error checking mechanism.
  311. # Instead, use strto* functions.
  312. sc_prohibit_atoi_atof:
  313. @prohibit='\<([fs]?scanf|ato([filq]|ll)) *\(' \
  314. halt='do not use *scan''f, ato''f, ato''i, ato''l, ato''ll or ato''q' \
  315. $(_sc_search_regexp)
  316. # Use STREQ rather than comparing strcmp == 0, or != 0.
  317. sp_ = strcmp *\(.+\)
  318. sc_prohibit_strcmp:
  319. @prohibit='! *strcmp *\(|\<$(sp_) *[!=]=|[!=]= *$(sp_)' \
  320. exclude='# *define STRN?EQ\(' \
  321. halt='replace strcmp calls above with STREQ/STRNEQ' \
  322. $(_sc_search_regexp)
  323. # Really. You don't want to use this function.
  324. # It may fail to NUL-terminate the destination,
  325. # and always NUL-pads out to the specified length.
  326. sc_prohibit_strncpy:
  327. @prohibit='\<strncpy *\(' \
  328. halt='do not use strncpy, period' \
  329. $(_sc_search_regexp)
  330. # Pass EXIT_*, not number, to usage, exit, and error (when exiting)
  331. # Convert all uses automatically, via these two commands:
  332. # git grep -l '\<exit *(1)' \
  333. # | grep -vEf .x-sc_prohibit_magic_number_exit \
  334. # | xargs --no-run-if-empty \
  335. # perl -pi -e 's/(^|[^.])\b(exit ?)\(1\)/$1$2(EXIT_FAILURE)/'
  336. # git grep -l '\<exit *(0)' \
  337. # | grep -vEf .x-sc_prohibit_magic_number_exit \
  338. # | xargs --no-run-if-empty \
  339. # perl -pi -e 's/(^|[^.])\b(exit ?)\(0\)/$1$2(EXIT_SUCCESS)/'
  340. sc_prohibit_magic_number_exit:
  341. @prohibit='(^|[^.])\<(usage|exit|error) ?\(-?[0-9]+[,)]' \
  342. exclude='exit \(77\)|error ?\(((0|77),|[^,]*)' \
  343. halt='use EXIT_* values rather than magic number' \
  344. $(_sc_search_regexp)
  345. # Using EXIT_SUCCESS as the first argument to error is misleading,
  346. # since when that parameter is 0, error does not exit. Use '0' instead.
  347. sc_error_exit_success:
  348. @prohibit='error *\(EXIT_SUCCESS,' \
  349. in_vc_files='\.[chly]$$' \
  350. halt='found error (EXIT_SUCCESS' \
  351. $(_sc_search_regexp)
  352. # "FATAL:" should be fully upper-cased in error messages
  353. # "WARNING:" should be fully upper-cased, or fully lower-cased
  354. sc_error_message_warn_fatal:
  355. @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \
  356. | grep -E '"Warning|"Fatal|"fatal' && \
  357. { echo '$(ME): use FATAL, WARNING or warning' 1>&2; \
  358. exit 1; } || :
  359. # Error messages should not start with a capital letter
  360. sc_error_message_uppercase:
  361. @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \
  362. | grep -E '"[A-Z]' \
  363. | grep -vE '"FATAL|"WARNING|"Java|"C#|PRIuMAX' && \
  364. { echo '$(ME): found capitalized error message' 1>&2; \
  365. exit 1; } || :
  366. # Error messages should not end with a period
  367. sc_error_message_period:
  368. @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \
  369. | grep -E '[^."]\."' && \
  370. { echo '$(ME): found error message ending in period' 1>&2; \
  371. exit 1; } || :
  372. sc_file_system:
  373. @prohibit=file''system \
  374. ignore_case=1 \
  375. halt='found use of "file''system"; spell it "file system"' \
  376. $(_sc_search_regexp)
  377. # Don't use cpp tests of this symbol. All code assumes config.h is included.
  378. sc_prohibit_have_config_h:
  379. @prohibit='^# *if.*HAVE''_CONFIG_H' \
  380. halt='found use of HAVE''_CONFIG_H; remove' \
  381. $(_sc_search_regexp)
  382. # Nearly all .c files must include <config.h>. However, we also permit this
  383. # via inclusion of a package-specific header, if cfg.mk specified one.
  384. # config_h_header must be suitable for grep -E.
  385. config_h_header ?= <config\.h>
  386. sc_require_config_h:
  387. @require='^# *include $(config_h_header)' \
  388. in_vc_files='\.c$$' \
  389. halt='the above files do not include <config.h>' \
  390. $(_sc_search_regexp)
  391. # You must include <config.h> before including any other header file.
  392. # This can possibly be via a package-specific header, if given by cfg.mk.
  393. sc_require_config_h_first:
  394. @if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then \
  395. fail=0; \
  396. for i in $$($(VC_LIST_EXCEPT) | grep '\.c$$'); do \
  397. grep '^# *include\>' $$i | sed 1q \
  398. | grep -E '^# *include $(config_h_header)' > /dev/null \
  399. || { echo $$i; fail=1; }; \
  400. done; \
  401. test $$fail = 1 && \
  402. { echo '$(ME): the above files include some other header' \
  403. 'before <config.h>' 1>&2; exit 1; } || :; \
  404. else :; \
  405. fi
  406. sc_prohibit_HAVE_MBRTOWC:
  407. @prohibit='\bHAVE_MBRTOWC\b' \
  408. halt="do not use $$prohibit; it is always defined" \
  409. $(_sc_search_regexp)
  410. # To use this "command" macro, you must first define two shell variables:
  411. # h: the header name, with no enclosing <> or ""
  412. # re: a regular expression that matches IFF something provided by $h is used.
  413. define _sc_header_without_use
  414. dummy=; : so we do not need a semicolon before each use; \
  415. h_esc=`echo '[<"]'"$$h"'[">]'|sed 's/\./\\\\./g'`; \
  416. if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then \
  417. files=$$(grep -l '^# *include '"$$h_esc" \
  418. $$($(VC_LIST_EXCEPT) | grep '\.c$$')) && \
  419. grep -LE "$$re" $$files | grep . && \
  420. { echo "$(ME): the above files include $$h but don't use it" \
  421. 1>&2; exit 1; } || :; \
  422. else :; \
  423. fi
  424. endef
  425. # Prohibit the inclusion of assert.h without an actual use of assert.
  426. sc_prohibit_assert_without_use:
  427. @h='assert.h' re='\<assert *\(' $(_sc_header_without_use)
  428. # Prohibit the inclusion of close-stream.h without an actual use.
  429. sc_prohibit_close_stream_without_use:
  430. @h='close-stream.h' re='\<close_stream *\(' $(_sc_header_without_use)
  431. # Prohibit the inclusion of getopt.h without an actual use.
  432. sc_prohibit_getopt_without_use:
  433. @h='getopt.h' re='\<getopt(_long)? *\(' $(_sc_header_without_use)
  434. # Don't include quotearg.h unless you use one of its functions.
  435. sc_prohibit_quotearg_without_use:
  436. @h='quotearg.h' re='\<quotearg(_[^ ]+)? *\(' $(_sc_header_without_use)
  437. # Don't include quote.h unless you use one of its functions.
  438. sc_prohibit_quote_without_use:
  439. @h='quote.h' re='\<quote((_n)? *\(|_quoting_options\>)' \
  440. $(_sc_header_without_use)
  441. # Don't include this header unless you use one of its functions.
  442. sc_prohibit_long_options_without_use:
  443. @h='long-options.h' re='\<parse_long_options *\(' \
  444. $(_sc_header_without_use)
  445. # Don't include this header unless you use one of its functions.
  446. sc_prohibit_inttostr_without_use:
  447. @h='inttostr.h' re='\<(off|[iu]max|uint)tostr *\(' \
  448. $(_sc_header_without_use)
  449. # Don't include this header unless you use one of its functions.
  450. sc_prohibit_ignore_value_without_use:
  451. @h='ignore-value.h' re='\<ignore_(value|ptr) *\(' \
  452. $(_sc_header_without_use)
  453. # Don't include this header unless you use one of its functions.
  454. sc_prohibit_error_without_use:
  455. @h='error.h' \
  456. re='\<error(_at_line|_print_progname|_one_per_line|_message_count)? *\('\
  457. $(_sc_header_without_use)
  458. # Don't include xalloc.h unless you use one of its functions.
  459. # Consider these symbols:
  460. # perl -lne '/^# *define (\w+)\(/ and print $1' lib/xalloc.h|grep -v '^__';
  461. # perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/xalloc.h
  462. # Divide into two sets on case, and filter each through this:
  463. # | sort | perl -MRegexp::Assemble -le \
  464. # 'print Regexp::Assemble->new(file => "/dev/stdin")->as_string'|sed 's/\?://g'
  465. # Note this was produced by the above:
  466. # _xa1 = \
  467. #x(((2n?)?re|c(har)?|n(re|m)|z)alloc|alloc_(oversized|die)|m(alloc|emdup)|strdup)
  468. # But we can do better, in at least two ways:
  469. # 1) take advantage of two "dup"-suffixed strings:
  470. # x(((2n?)?re|c(har)?|n(re|m)|[mz])alloc|alloc_(oversized|die)|(mem|str)dup)
  471. # 2) notice that "c(har)?|[mz]" is equivalent to the shorter and more readable
  472. # "char|[cmz]"
  473. # x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
  474. _xa1 = x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
  475. _xa2 = X([CZ]|N?M)ALLOC
  476. sc_prohibit_xalloc_without_use:
  477. @h='xalloc.h' \
  478. re='\<($(_xa1)|$(_xa2)) *\('\
  479. $(_sc_header_without_use)
  480. # Extract function names:
  481. # perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/hash.h
  482. _hash_re = \
  483. clear|delete|free|get_(first|next)|insert|lookup|print_statistics|reset_tuning
  484. _hash_fn = \<($(_hash_re)) *\(
  485. _hash_struct = (struct )?\<[Hh]ash_(table|tuning)\>
  486. sc_prohibit_hash_without_use:
  487. @h='hash.h' \
  488. re='$(_hash_fn)|$(_hash_struct)'\
  489. $(_sc_header_without_use)
  490. sc_prohibit_cloexec_without_use:
  491. @h='cloexec.h' re='\<(set_cloexec_flag|dup_cloexec) *\(' \
  492. $(_sc_header_without_use)
  493. sc_prohibit_posixver_without_use:
  494. @h='posixver.h' re='\<posix2_version *\(' $(_sc_header_without_use)
  495. sc_prohibit_same_without_use:
  496. @h='same.h' re='\<same_name *\(' $(_sc_header_without_use)
  497. sc_prohibit_hash_pjw_without_use:
  498. @h='hash-pjw.h' \
  499. re='\<hash_pjw\>' \
  500. $(_sc_header_without_use)
  501. sc_prohibit_safe_read_without_use:
  502. @h='safe-read.h' re='(\<SAFE_READ_ERROR\>|\<safe_read *\()' \
  503. $(_sc_header_without_use)
  504. sc_prohibit_argmatch_without_use:
  505. @h='argmatch.h' \
  506. re='(\<(ARRAY_CARDINALITY|X?ARGMATCH(|_TO_ARGUMENT|_VERIFY))\>|\<(invalid_arg|argmatch(_exit_fn|_(in)?valid)?) *\()' \
  507. $(_sc_header_without_use)
  508. sc_prohibit_canonicalize_without_use:
  509. @h='canonicalize.h' \
  510. re='CAN_(EXISTING|ALL_BUT_LAST|MISSING)|canonicalize_(mode_t|filename_mode|file_name)' \
  511. $(_sc_header_without_use)
  512. sc_prohibit_root_dev_ino_without_use:
  513. @h='root-dev-ino.h' \
  514. re='(\<ROOT_DEV_INO_(CHECK|WARN)\>|\<get_root_dev_ino *\()' \
  515. $(_sc_header_without_use)
  516. sc_prohibit_openat_without_use:
  517. @h='openat.h' \
  518. re='\<(openat_(permissive|needs_fchdir|(save|restore)_fail)|l?(stat|ch(own|mod))at|(euid)?accessat)\>' \
  519. $(_sc_header_without_use)
  520. # Prohibit the inclusion of c-ctype.h without an actual use.
  521. ctype_re = isalnum|isalpha|isascii|isblank|iscntrl|isdigit|isgraph|islower\
  522. |isprint|ispunct|isspace|isupper|isxdigit|tolower|toupper
  523. sc_prohibit_c_ctype_without_use:
  524. @h='c-ctype.h' re='\<c_($(ctype_re)) *\(' \
  525. $(_sc_header_without_use)
  526. # The following list was generated by running:
  527. # man signal.h|col -b|perl -ne '/bsd_signal.*;/.../sigwaitinfo.*;/ and print' \
  528. # | perl -lne '/^\s+(?:int|void).*?(\w+).*/ and print $1' | fmt
  529. _sig_functions = \
  530. bsd_signal kill killpg pthread_kill pthread_sigmask raise sigaction \
  531. sigaddset sigaltstack sigdelset sigemptyset sigfillset sighold sigignore \
  532. siginterrupt sigismember signal sigpause sigpending sigprocmask sigqueue \
  533. sigrelse sigset sigsuspend sigtimedwait sigwait sigwaitinfo
  534. _sig_function_re = $(subst $(_sp),|,$(strip $(_sig_functions)))
  535. # The following were extracted from "man signal.h" manually.
  536. _sig_types_and_consts = \
  537. MINSIGSTKSZ SA_NOCLDSTOP SA_NOCLDWAIT SA_NODEFER SA_ONSTACK \
  538. SA_RESETHAND SA_RESTART SA_SIGINFO SIGEV_NONE SIGEV_SIGNAL \
  539. SIGEV_THREAD SIGSTKSZ SIG_BLOCK SIG_SETMASK SIG_UNBLOCK SS_DISABLE \
  540. SS_ONSTACK mcontext_t pid_t sig_atomic_t sigevent siginfo_t sigset_t \
  541. sigstack sigval stack_t ucontext_t
  542. # generated via this:
  543. # perl -lne '/^#ifdef (SIG\w+)/ and print $1' lib/sig2str.c|sort -u|fmt -70
  544. _sig_names = \
  545. SIGABRT SIGALRM SIGALRM1 SIGBUS SIGCANCEL SIGCHLD SIGCLD SIGCONT \
  546. SIGDANGER SIGDIL SIGEMT SIGFPE SIGFREEZE SIGGRANT SIGHUP SIGILL \
  547. SIGINFO SIGINT SIGIO SIGIOT SIGKAP SIGKILL SIGKILLTHR SIGLOST SIGLWP \
  548. SIGMIGRATE SIGMSG SIGPHONE SIGPIPE SIGPOLL SIGPRE SIGPROF SIGPWR \
  549. SIGQUIT SIGRETRACT SIGSAK SIGSEGV SIGSOUND SIGSTKFLT SIGSTOP SIGSYS \
  550. SIGTERM SIGTHAW SIGTRAP SIGTSTP SIGTTIN SIGTTOU SIGURG SIGUSR1 \
  551. SIGUSR2 SIGVIRT SIGVTALRM SIGWAITING SIGWINCH SIGWIND SIGWINDOW \
  552. SIGXCPU SIGXFSZ
  553. _sig_syms_re = $(subst $(_sp),|,$(strip $(_sig_names) $(_sig_types_and_consts)))
  554. # Prohibit the inclusion of signal.h without an actual use.
  555. sc_prohibit_signal_without_use:
  556. @h='signal.h' \
  557. re='\<($(_sig_function_re)) *\(|\<($(_sig_syms_re))\>' \
  558. $(_sc_header_without_use)
  559. # Don't include stdio--.h unless you use one of its functions.
  560. sc_prohibit_stdio--_without_use:
  561. @h='stdio--.h' re='\<((f(re)?|p)open|tmpfile) *\(' \
  562. $(_sc_header_without_use)
  563. # Don't include stdio-safer.h unless you use one of its functions.
  564. sc_prohibit_stdio-safer_without_use:
  565. @h='stdio-safer.h' re='\<((f(re)?|p)open|tmpfile)_safer *\(' \
  566. $(_sc_header_without_use)
  567. # Prohibit the inclusion of strings.h without a sensible use.
  568. # Using the likes of bcmp, bcopy, bzero, index or rindex is not sensible.
  569. sc_prohibit_strings_without_use:
  570. @h='strings.h' \
  571. re='\<(strn?casecmp|ffs(ll)?)\>' \
  572. $(_sc_header_without_use)
  573. # Get the list of symbol names with this:
  574. # perl -lne '/^# *define ([A-Z]\w+)\(/ and print $1' lib/intprops.h|fmt
  575. _intprops_names = \
  576. TYPE_IS_INTEGER TYPE_TWOS_COMPLEMENT TYPE_ONES_COMPLEMENT \
  577. TYPE_SIGNED_MAGNITUDE TYPE_SIGNED TYPE_MINIMUM TYPE_MAXIMUM \
  578. INT_BITS_STRLEN_BOUND INT_STRLEN_BOUND INT_BUFSIZE_BOUND \
  579. INT_ADD_RANGE_OVERFLOW INT_SUBTRACT_RANGE_OVERFLOW \
  580. INT_NEGATE_RANGE_OVERFLOW INT_MULTIPLY_RANGE_OVERFLOW \
  581. INT_DIVIDE_RANGE_OVERFLOW INT_REMAINDER_RANGE_OVERFLOW \
  582. INT_LEFT_SHIFT_RANGE_OVERFLOW INT_ADD_OVERFLOW INT_SUBTRACT_OVERFLOW \
  583. INT_NEGATE_OVERFLOW INT_MULTIPLY_OVERFLOW INT_DIVIDE_OVERFLOW \
  584. INT_REMAINDER_OVERFLOW INT_LEFT_SHIFT_OVERFLOW
  585. _intprops_syms_re = $(subst $(_sp),|,$(strip $(_intprops_names)))
  586. # Prohibit the inclusion of intprops.h without an actual use.
  587. sc_prohibit_intprops_without_use:
  588. @h='intprops.h' \
  589. re='\<($(_intprops_syms_re)) *\(' \
  590. $(_sc_header_without_use)
  591. _stddef_syms_re = NULL|offsetof|ptrdiff_t|size_t|wchar_t
  592. # Prohibit the inclusion of stddef.h without an actual use.
  593. sc_prohibit_stddef_without_use:
  594. @h='stddef.h' \
  595. re='\<($(_stddef_syms_re))\>' \
  596. $(_sc_header_without_use)
  597. _de1 = dirfd|(close|(fd)?open|read|rewind|seek|tell)dir(64)?(_r)?
  598. _de2 = (versionsort|struct dirent|getdirentries|alphasort|scandir(at)?)(64)?
  599. _de3 = MAXNAMLEN|DIR|ino_t|d_ino|d_fileno|d_namlen
  600. _dirent_syms_re = $(_de1)|$(_de2)|$(_de3)
  601. # Prohibit the inclusion of dirent.h without an actual use.
  602. sc_prohibit_dirent_without_use:
  603. @h='dirent.h' \
  604. re='\<($(_dirent_syms_re))\>' \
  605. $(_sc_header_without_use)
  606. # Prohibit the inclusion of verify.h without an actual use.
  607. sc_prohibit_verify_without_use:
  608. @h='verify.h' \
  609. re='\<(verify(true|expr)?|static_assert) *\(' \
  610. $(_sc_header_without_use)
  611. # Don't include xfreopen.h unless you use one of its functions.
  612. sc_prohibit_xfreopen_without_use:
  613. @h='xfreopen.h' re='\<xfreopen *\(' $(_sc_header_without_use)
  614. sc_obsolete_symbols:
  615. @prohibit='\<(HAVE''_FCNTL_H|O''_NDELAY)\>' \
  616. halt='do not use HAVE''_FCNTL_H or O'_NDELAY \
  617. $(_sc_search_regexp)
  618. # FIXME: warn about definitions of EXIT_FAILURE, EXIT_SUCCESS, STREQ
  619. # Each nonempty ChangeLog line must start with a year number, or a TAB.
  620. sc_changelog:
  621. @prohibit='^[^12 ]' \
  622. in_vc_files='^ChangeLog$$' \
  623. halt='found unexpected prefix in a ChangeLog' \
  624. $(_sc_search_regexp)
  625. # Ensure that each .c file containing a "main" function also
  626. # calls set_program_name.
  627. sc_program_name:
  628. @require='set_program_name *\(m?argv\[0\]\);' \
  629. in_vc_files='\.c$$' \
  630. containing='\<main *(' \
  631. halt='the above files do not call set_program_name' \
  632. $(_sc_search_regexp)
  633. # Ensure that each .c file containing a "main" function also
  634. # calls bindtextdomain.
  635. sc_bindtextdomain:
  636. @require='bindtextdomain *\(' \
  637. in_vc_files='\.c$$' \
  638. containing='\<main *(' \
  639. halt='the above files do not call bindtextdomain' \
  640. $(_sc_search_regexp)
  641. # Require that the final line of each test-lib.sh-using test be this one:
  642. # Exit $fail
  643. # Note: this test requires GNU grep's --label= option.
  644. Exit_witness_file ?= tests/test-lib.sh
  645. Exit_base := $(notdir $(Exit_witness_file))
  646. sc_require_test_exit_idiom:
  647. @if test -f $(srcdir)/$(Exit_witness_file); then \
  648. die=0; \
  649. for i in $$(grep -l -F 'srcdir/$(Exit_base)' \
  650. $$($(VC_LIST) tests)); do \
  651. tail -n1 $$i | grep '^Exit .' > /dev/null \
  652. && : || { die=1; echo $$i; } \
  653. done; \
  654. test $$die = 1 && \
  655. { echo 1>&2 '$(ME): the final line in each of the above is not:'; \
  656. echo 1>&2 'Exit something'; \
  657. exit 1; } || :; \
  658. fi
  659. sc_trailing_blank:
  660. @prohibit='[ ]$$' \
  661. halt='found trailing blank(s)' \
  662. exclude='^Binary file .* matches$$' \
  663. $(_sc_search_regexp)
  664. # Match lines like the following, but where there is only one space
  665. # between the options and the description:
  666. # -D, --all-repeated[=delimit-method] print all duplicate lines\n
  667. longopt_re = --[a-z][0-9A-Za-z-]*(\[?=[0-9A-Za-z-]*\]?)?
  668. sc_two_space_separator_in_usage:
  669. @prohibit='^ *(-[A-Za-z],)? $(longopt_re) [^ ].*\\$$' \
  670. halt='help2man requires at least two spaces between an option and its description'\
  671. $(_sc_search_regexp)
  672. # A regexp matching function names like "error" that may be used
  673. # to emit translatable messages.
  674. _gl_translatable_diag_func_re ?= error
  675. # Look for diagnostics that aren't marked for translation.
  676. # This won't find any for which error's format string is on a separate line.
  677. sc_unmarked_diagnostics:
  678. @prohibit='\<$(_gl_translatable_diag_func_re) *\([^"]*"[^"]*[a-z]{3}' \
  679. exclude='(_|ngettext ?)\(' \
  680. halt='found unmarked diagnostic(s)' \
  681. $(_sc_search_regexp)
  682. # Avoid useless parentheses like those in this example:
  683. # #if defined (SYMBOL) || defined (SYM2)
  684. sc_useless_cpp_parens:
  685. @prohibit='^# *if .*defined *\(' \
  686. halt='found useless parentheses in cpp directive' \
  687. $(_sc_search_regexp)
  688. # List headers for which HAVE_HEADER_H is always true, assuming you are
  689. # using the appropriate gnulib module. CAUTION: for each "unnecessary"
  690. # #if HAVE_HEADER_H that you remove, be sure that your project explicitly
  691. # requires the gnulib module that guarantees the usability of that header.
  692. gl_assured_headers_ = \
  693. cd $(gnulib_dir)/lib && echo *.in.h|sed 's/\.in\.h//g'
  694. # Convert the list of names to upper case, and replace each space with "|".
  695. az_ = abcdefghijklmnopqrstuvwxyz
  696. AZ_ = ABCDEFGHIJKLMNOPQRSTUVWXYZ
  697. gl_header_upper_case_or_ = \
  698. $$($(gl_assured_headers_) \
  699. | tr $(az_)/.- $(AZ_)___ \
  700. | tr -s ' ' '|' \
  701. )
  702. sc_prohibit_always_true_header_tests:
  703. @or=$(gl_header_upper_case_or_); \
  704. re="HAVE_($$or)_H"; \
  705. prohibit='\<'"$$re"'\>' \
  706. halt=$$(printf '%s\n' \
  707. 'do not test the above HAVE_<header>_H symbol(s);' \
  708. ' with the corresponding gnulib module, they are always true') \
  709. $(_sc_search_regexp)
  710. sc_prohibit_defined_have_decl_tests:
  711. @prohibit='#[ ]*if(n?def|.*\<defined)\>[ (]+HAVE_DECL_' \
  712. halt='HAVE_DECL macros are always defined' \
  713. $(_sc_search_regexp)
  714. # ==================================================================
  715. gl_other_headers_ ?= \
  716. intprops.h \
  717. openat.h \
  718. stat-macros.h
  719. # Perl -lne code to extract "significant" cpp-defined symbols from a
  720. # gnulib header file, eliminating a few common false-positives.
  721. # The exempted names below are defined only conditionally in gnulib,
  722. # and hence sometimes must/may be defined in application code.
  723. gl_extract_significant_defines_ = \
  724. /^\# *define ([^_ (][^ (]*)(\s*\(|\s+\w+)/\
  725. && $$2 !~ /(?:rpl_|_used_without_)/\
  726. && $$1 !~ /^(?:NSIG|ENODATA)$$/\
  727. && $$1 !~ /^(?:SA_RESETHAND|SA_RESTART)$$/\
  728. and print $$1
  729. # Create a list of regular expressions matching the names
  730. # of macros that are guaranteed to be defined by parts of gnulib.
  731. define def_sym_regex
  732. gen_h=$(gl_generated_headers_); \
  733. (cd $(gnulib_dir)/lib; \
  734. for f in *.in.h $(gl_other_headers_); do \
  735. test -f $$f \
  736. && perl -lne '$(gl_extract_significant_defines_)' $$f; \
  737. done; \
  738. ) | sort -u \
  739. | sed 's/^/^ *# *(define|undef) */;s/$$/\\>/'
  740. endef
  741. # Don't define macros that we already get from gnulib header files.
  742. sc_prohibit_always-defined_macros:
  743. @if test -d $(gnulib_dir); then \
  744. case $$(echo all: | grep -l -f - Makefile) in Makefile);; *) \
  745. echo '$(ME): skipping $@: you lack GNU grep' 1>&2; exit 0;; \
  746. esac; \
  747. $(def_sym_regex) | grep -E -f - $$($(VC_LIST_EXCEPT)) \
  748. && { echo '$(ME): define the above via some gnulib .h file' \
  749. 1>&2; exit 1; } || :; \
  750. fi
  751. # ==================================================================
  752. # Prohibit checked in backup files.
  753. sc_prohibit_backup_files:
  754. @$(VC_LIST) | grep '~$$' && \
  755. { echo '$(ME): found version controlled backup file' 1>&2; \
  756. exit 1; } || :
  757. # Require the latest GPL.
  758. sc_GPL_version:
  759. @prohibit='either ''version [^3]' \
  760. halt='GPL vN, N!=3' \
  761. $(_sc_search_regexp)
  762. # Require the latest GFDL. Two regexp, since some .texi files end up
  763. # line wrapping between 'Free Documentation License,' and 'Version'.
  764. _GFDL_regexp = (Free ''Documentation.*Version 1\.[^3]|Version 1\.[^3] or any)
  765. sc_GFDL_version:
  766. @prohibit='$(_GFDL_regexp)' \
  767. halt='GFDL vN, N!=3' \
  768. $(_sc_search_regexp)
  769. # Don't use Texinfo's @acronym{}.
  770. # http://lists.gnu.org/archive/html/bug-gnulib/2010-03/msg00321.html
  771. texinfo_suffix_re_ ?= \.(txi|texi(nfo)?)$$
  772. sc_texinfo_acronym:
  773. @prohibit='@acronym\{' \
  774. in_vc_files='$(texinfo_suffix_re_)' \
  775. halt='found use of Texinfo @acronym{}' \
  776. $(_sc_search_regexp)
  777. cvs_keywords = \
  778. Author|Date|Header|Id|Name|Locker|Log|RCSfile|Revision|Source|State
  779. sc_prohibit_cvs_keyword:
  780. @prohibit='\$$($(cvs_keywords))\$$' \
  781. halt='do not use CVS keyword expansion' \
  782. $(_sc_search_regexp)
  783. # This Perl code is slightly obfuscated. Not only is each "$" doubled
  784. # because it's in a Makefile, but the $$c's are comments; we cannot
  785. # use "#" due to the way the script ends up concatenated onto one line.
  786. # It would be much more concise, and would produce better output (including
  787. # counts) if written as:
  788. # perl -ln -0777 -e '/\n(\n+)$/ and print "$ARGV: ".length $1' ...
  789. # but that would be far less efficient, reading the entire contents
  790. # of each file, rather than just the last two bytes of each.
  791. # In addition, while the code below detects both blank lines and a missing
  792. # newline at EOF, the above detects only the former.
  793. #
  794. # This is a perl script that is expected to be the single-quoted argument
  795. # to a command-line "-le". The remaining arguments are file names.
  796. # Print the name of each file that does not end in exactly one newline byte.
  797. # I.e., warn if there are blank lines (2 or more newlines), or if the
  798. # last byte is not a newline. However, currently we don't complain
  799. # about any file that contains exactly one byte.
  800. # Exit nonzero if at least one such file is found, otherwise, exit 0.
  801. # Warn about, but otherwise ignore open failure. Ignore seek/read failure.
  802. #
  803. # Use this if you want to remove trailing empty lines from selected files:
  804. # perl -pi -0777 -e 's/\n\n+$/\n/' files...
  805. #
  806. require_exactly_one_NL_at_EOF_ = \
  807. foreach my $$f (@ARGV) \
  808. { \
  809. open F, "<", $$f or (warn "failed to open $$f: $$!\n"), next; \
  810. my $$p = sysseek (F, -2, 2); \
  811. my $$c = "seek failure probably means file has < 2 bytes; ignore"; \
  812. my $$last_two_bytes; \
  813. defined $$p and $$p = sysread F, $$last_two_bytes, 2; \
  814. close F; \
  815. $$c = "ignore read failure"; \
  816. $$p && ($$last_two_bytes eq "\n\n" \
  817. || substr ($$last_two_bytes,1) ne "\n") \
  818. and (print $$f), $$fail=1; \
  819. } \
  820. END { exit defined $$fail }
  821. sc_prohibit_empty_lines_at_EOF:
  822. @perl -le '$(require_exactly_one_NL_at_EOF_)' $$($(VC_LIST_EXCEPT)) \
  823. || { echo '$(ME): empty line(s) or no newline at EOF' \
  824. 1>&2; exit 1; } || :
  825. # Make sure we don't use st_blocks. Use ST_NBLOCKS instead.
  826. # This is a bit of a kludge, since it prevents use of the string
  827. # even in comments, but for now it does the job with no false positives.
  828. sc_prohibit_stat_st_blocks:
  829. @prohibit='[.>]st_blocks' \
  830. halt='do not use st_blocks; use ST_NBLOCKS' \
  831. $(_sc_search_regexp)
  832. # Make sure we don't define any S_IS* macros in src/*.c files.
  833. # They're already defined via gnulib's sys/stat.h replacement.
  834. sc_prohibit_S_IS_definition:
  835. @prohibit='^ *# *define *S_IS' \
  836. halt='do not define S_IS* macros; include <sys/stat.h>' \
  837. $(_sc_search_regexp)
  838. # Perl block to convert a match to FILE_NAME:LINENO:TEST,
  839. # that is shared by two definitions below.
  840. perl_filename_lineno_text_ = \
  841. -e ' {' \
  842. -e ' $$n = ($$` =~ tr/\n/\n/ + 1);' \
  843. -e ' ($$v = $$&) =~ s/\n/\\n/g;' \
  844. -e ' print "$$ARGV:$$n:$$v\n";' \
  845. -e ' }'
  846. prohibit_doubled_word_RE_ ?= \
  847. /\b(then?|[iao]n|i[fst]|but|f?or|at|and|[dt]o)\s+\1\b/gims
  848. prohibit_doubled_word_ = \
  849. -e 'while ($(prohibit_doubled_word_RE_))' \
  850. $(perl_filename_lineno_text_)
  851. # Define this to a regular expression that matches
  852. # any filename:dd:match lines you want to ignore.
  853. # The default is to ignore no matches.
  854. ignore_doubled_word_match_RE_ ?= ^$$
  855. sc_prohibit_doubled_word:
  856. @perl -n -0777 $(prohibit_doubled_word_) $$($(VC_LIST_EXCEPT)) \
  857. | grep -vE '$(ignore_doubled_word_match_RE_)' \
  858. | grep . && { echo '$(ME): doubled words' 1>&2; exit 1; } || :
  859. # A regular expression matching undesirable combinations of words like
  860. # "can not"; this matches them even when the two words appear on different
  861. # lines, but not when there is an intervening delimiter like "#" or "*".
  862. # Similarly undesirable, "See @xref{...}", since an @xref should start
  863. # a sentence. Explicitly prohibit any prefix of "see" or "also".
  864. # Also prohibit a prefix matching "\w+ +".
  865. # @pxref gets the same see/also treatment and should be parenthesized;
  866. # presume it must *not* start a sentence.
  867. bad_xref_re_ ?= (?:[\w,:;] +|(?:see|also)\s+)\@xref\{
  868. bad_pxref_re_ ?= (?:[.!?]|(?:see|also))\s+\@pxref\{
  869. prohibit_undesirable_word_seq_RE_ ?= \
  870. /(?:\bcan\s+not\b|$(bad_xref_re_)|$(bad_pxref_re_))/gims
  871. prohibit_undesirable_word_seq_ = \
  872. -e 'while ($(prohibit_undesirable_word_seq_RE_))' \
  873. $(perl_filename_lineno_text_)
  874. # Define this to a regular expression that matches
  875. # any filename:dd:match lines you want to ignore.
  876. # The default is to ignore no matches.
  877. ignore_undesirable_word_sequence_RE_ ?= ^$$
  878. sc_prohibit_undesirable_word_seq:
  879. @perl -n -0777 $(prohibit_undesirable_word_seq_) \
  880. $$($(VC_LIST_EXCEPT)) \
  881. | grep -vE '$(ignore_undesirable_word_sequence_RE_)' | grep . \
  882. && { echo '$(ME): undesirable word sequence' >&2; exit 1; } || :
  883. _ptm1 = use "test C1 && test C2", not "test C1 -''a C2"
  884. _ptm2 = use "test C1 || test C2", not "test C1 -''o C2"
  885. # Using test's -a and -o operators is not portable.
  886. # We prefer test over [, since the latter is spelled [[ in configure.ac.
  887. sc_prohibit_test_minus_ao:
  888. @prohibit='(\<test| \[+) .+ -[ao] ' \
  889. halt='$(_ptm1); $(_ptm2)' \
  890. $(_sc_search_regexp)
  891. # Avoid a test bashism.
  892. sc_prohibit_test_double_equal:
  893. @prohibit='(\<test| \[+) .+ == ' \
  894. containing='#! */bin/[a-z]*sh' \
  895. halt='use "test x = x", not "test x =''= x"' \
  896. $(_sc_search_regexp)
  897. # Each program that uses proper_name_utf8 must link with one of the
  898. # ICONV libraries. Otherwise, some ICONV library must appear in LDADD.
  899. # The perl -0777 invocation below extracts the possibly-multi-line
  900. # definition of LDADD from the appropriate Makefile.am and exits 0
  901. # when it contains "ICONV".
  902. sc_proper_name_utf8_requires_ICONV:
  903. @progs=$$(grep -l 'proper_name_utf8 ''("' $$($(VC_LIST_EXCEPT)));\
  904. if test "x$$progs" != x; then \
  905. fail=0; \
  906. for p in $$progs; do \
  907. dir=$$(dirname "$$p"); \
  908. perl -0777 \
  909. -ne 'exit !(/^LDADD =(.+?[^\\]\n)/ms && $$1 =~ /ICONV/)' \
  910. $$dir/Makefile.am && continue; \
  911. base=$$(basename "$$p" .c); \
  912. grep "$${base}_LDADD.*ICONV)" $$dir/Makefile.am > /dev/null \
  913. || { fail=1; echo 1>&2 "$(ME): $$p uses proper_name_utf8"; }; \
  914. done; \
  915. test $$fail = 1 && \
  916. { echo 1>&2 '$(ME): the above do not link with any ICONV library'; \
  917. exit 1; } || :; \
  918. fi
  919. # Warn about "c0nst struct Foo const foo[]",
  920. # but not about "char const *const foo" or "#define const const".
  921. sc_redundant_const:
  922. @prohibit='\bconst\b[[:space:][:alnum:]]{2,}\bconst\b' \
  923. halt='redundant "const" in declarations' \
  924. $(_sc_search_regexp)
  925. sc_const_long_option:
  926. @prohibit='^ *static.*struct option ' \
  927. exclude='const struct option|struct option const' \
  928. halt='add "const" to the above declarations' \
  929. $(_sc_search_regexp)
  930. NEWS_hash = \
  931. $$(sed -n '/^\*.* $(PREV_VERSION_REGEXP) ([0-9-]*)/,$$p' \
  932. $(srcdir)/NEWS \
  933. | perl -0777 -pe \
  934. 's/^Copyright.+?Free\sSoftware\sFoundation,\sInc\.\n//ms' \
  935. | md5sum - \
  936. | sed 's/ .*//')
  937. # Ensure that we don't accidentally insert an entry into an old NEWS block.
  938. sc_immutable_NEWS:
  939. @if test -f $(srcdir)/NEWS; then \
  940. test "$(NEWS_hash)" = '$(old_NEWS_hash)' && : || \
  941. { echo '$(ME): you have modified old NEWS' 1>&2; exit 1; }; \
  942. fi
  943. # Update the hash stored above. Do this after each release and
  944. # for any corrections to old entries.
  945. update-NEWS-hash: NEWS
  946. perl -pi -e 's/^(old_NEWS_hash[ \t]+:?=[ \t]+).*/$${1}'"$(NEWS_hash)/" \
  947. $(srcdir)/cfg.mk
  948. # Ensure that we use only the standard $(VAR) notation,
  949. # not @...@ in Makefile.am, now that we can rely on automake
  950. # to emit a definition for each substituted variable.
  951. # However, there is still one case in which @VAR@ use is not just
  952. # legitimate, but actually required: when augmenting an automake-defined
  953. # variable with a prefix. For example, gettext uses this:
  954. # MAKEINFO = env LANG= LC_MESSAGES= LC_ALL= LANGUAGE= @MAKEINFO@
  955. # otherwise, makeinfo would put German or French (current locale)
  956. # navigation hints in the otherwise-English documentation.
  957. #
  958. # Allow the package to add exceptions via a hook in cfg.mk;
  959. # for example, @PRAGMA_SYSTEM_HEADER@ can be permitted by
  960. # setting this to ' && !/PRAGMA_SYSTEM_HEADER/'.
  961. _makefile_at_at_check_exceptions ?=
  962. sc_makefile_at_at_check:
  963. @perl -ne '/\@\w+\@/' \
  964. -e ' && !/(\w+)\s+=.*\@\1\@$$/' \
  965. -e ''$(_makefile_at_at_check_exceptions) \
  966. -e 'and (print "$$ARGV:$$.: $$_"), $$m=1; END {exit !$$m}' \
  967. $$($(VC_LIST_EXCEPT) | grep -E '(^|/)(Makefile\.am|[^/]+\.mk)$$') \
  968. && { echo '$(ME): use $$(...), not @...@' 1>&2; exit 1; } || :
  969. news-check: NEWS
  970. $(AM_V_GEN)if sed -n $(news-check-lines-spec)p $< \
  971. | grep -E $(news-check-regexp) >/dev/null; then \
  972. :; \
  973. else \
  974. echo 'NEWS: $$(news-check-regexp) failed to match' 1>&2; \
  975. exit 1; \
  976. fi
  977. sc_makefile_TAB_only_indentation:
  978. @prohibit='^ [ ]{8}' \
  979. in_vc_files='akefile|\.mk$$' \
  980. halt='found TAB-8-space indentation' \
  981. $(_sc_search_regexp)
  982. sc_m4_quote_check:
  983. @prohibit='(AC_DEFINE(_UNQUOTED)?|AC_DEFUN)\([^[]' \
  984. in_vc_files='(^configure\.ac|\.m4)$$' \
  985. halt='quote the first arg to AC_DEF*' \
  986. $(_sc_search_regexp)
  987. fix_po_file_diag = \
  988. 'you have changed the set of files with translatable diagnostics;\n\
  989. apply the above patch\n'
  990. # Verify that all source files using _() (more specifically, files that
  991. # match $(_gl_translatable_string_re)) are listed in po/POTFILES.in.
  992. po_file ?= $(srcdir)/po/POTFILES.in
  993. generated_files ?= $(srcdir)/lib/*.[ch]
  994. _gl_translatable_string_re ?= \b(N?_|gettext *)\([^)"]*("|$$)
  995. sc_po_check:
  996. @if test -f $(po_file); then \
  997. grep -E -v '^(#|$$)' $(po_file) \
  998. | grep -v '^src/false\.c$$' | sort > $@-1; \
  999. files=; \
  1000. for file in $$($(VC_LIST_EXCEPT)) $(generated_files); do \
  1001. test -r $$file || continue; \
  1002. case $$file in \
  1003. *.m4|*.mk) continue ;; \
  1004. *.?|*.??) ;; \
  1005. *) continue;; \
  1006. esac; \
  1007. case $$file in \
  1008. *.[ch]) \
  1009. base=`expr " $$file" : ' \(.*\)\..'`; \
  1010. { test -f $$base.l || test -f $$base.y; } && continue;; \
  1011. esac; \
  1012. files="$$files $$file"; \
  1013. done; \
  1014. grep -E -l '$(_gl_translatable_string_re)' $$files \
  1015. | sed 's|^$(_dot_escaped_srcdir)/||' | sort -u > $@-2; \
  1016. diff -u -L $(po_file) -L $(po_file) $@-1 $@-2 \
  1017. || { printf '$(ME): '$(fix_po_file_diag) 1>&2; exit 1; }; \
  1018. rm -f $@-1 $@-2; \
  1019. fi
  1020. # Sometimes it is useful to change the PATH environment variable
  1021. # in Makefiles. When doing so, it's better not to use the Unix-centric
  1022. # path separator of ':', but rather the automake-provided '$(PATH_SEPARATOR)'.
  1023. msg = 'Do not use ":" above; use $$(PATH_SEPARATOR) instead'
  1024. sc_makefile_path_separator_check:
  1025. @prohibit='PATH[=].*:' \
  1026. in_vc_files='akefile|\.mk$$' \
  1027. halt=$(msg) \
  1028. $(_sc_search_regexp)
  1029. # Check that 'make alpha' will not fail at the end of the process,
  1030. # i.e., when pkg-M.N.tar.xz already exists (either in "." or in ../release)
  1031. # and is read-only.
  1032. writable-files:
  1033. $(AM_V_GEN)if test -d $(release_archive_dir); then \
  1034. for file in $(DIST_ARCHIVES); do \
  1035. for p in ./ $(release_archive_dir)/; do \
  1036. test -e $$p$$file || continue; \
  1037. test -w $$p$$file \
  1038. || { echo ERROR: $$p$$file is not writable; fail=1; }; \
  1039. done; \
  1040. done; \
  1041. test "$$fail" && exit 1 || : ; \
  1042. else :; \
  1043. fi
  1044. v_etc_file = $(gnulib_dir)/lib/version-etc.c
  1045. sample-test = tests/sample-test
  1046. texi = doc/$(PACKAGE).texi
  1047. # Make sure that the copyright date in $(v_etc_file) is up to date.
  1048. # Do the same for the $(sample-test) and the main doc/.texi file.
  1049. sc_copyright_check:
  1050. @require='enum { COPYRIGHT_YEAR = '$$(date +%Y)' };' \
  1051. in_files=$(v_etc_file) \
  1052. halt='out of date copyright in $(v_etc_file); update it' \
  1053. $(_sc_search_regexp)
  1054. @require='# Copyright \(C\) '$$(date +%Y)' Free' \
  1055. in_vc_files=$(sample-test) \
  1056. halt='out of date copyright in $(sample-test); update it' \
  1057. $(_sc_search_regexp)
  1058. @require='Copyright @copyright\{\} .*'$$(date +%Y)' Free' \
  1059. in_vc_files=$(texi) \
  1060. halt='out of date copyright in $(texi); update it' \
  1061. $(_sc_search_regexp)
  1062. # If tests/help-version exists and seems to be new enough, assume that its
  1063. # use of init.sh and path_prepend_ is correct, and ensure that every other
  1064. # use of init.sh is identical.
  1065. # This is useful because help-version cross-checks prog --version
  1066. # with $(VERSION), which verifies that its path_prepend_ invocation
  1067. # sets PATH correctly. This is an inexpensive way to ensure that
  1068. # the other init.sh-using tests also get it right.
  1069. _hv_file ?= $(srcdir)/tests/help-version
  1070. _hv_regex_weak ?= ^ *\. .*/init\.sh"
  1071. # Fix syntax-highlighters "
  1072. _hv_regex_strong ?= ^ *\. "\$${srcdir=\.}/init\.sh"
  1073. sc_cross_check_PATH_usage_in_tests:
  1074. @if test -f $(_hv_file); then \
  1075. grep -l 'VERSION mismatch' $(_hv_file) >/dev/null \
  1076. || { echo "$@: skipped: no such file: $(_hv_file)" 1>&2; \
  1077. exit 0; }; \
  1078. grep -lE '$(_hv_regex_strong)' $(_hv_file) >/dev/null \
  1079. || { echo "$@: $(_hv_file) lacks conforming use of init.sh" 1>&2; \
  1080. exit 1; }; \
  1081. good=$$(grep -E '$(_hv_regex_strong)' $(_hv_file)); \
  1082. grep -LFx "$$good" \
  1083. $$(grep -lE '$(_hv_regex_weak)' $$($(VC_LIST_EXCEPT))) \
  1084. | grep . && \
  1085. { echo "$(ME): the above files use path_prepend_ inconsistently" \
  1086. 1>&2; exit 1; } || :; \
  1087. fi
  1088. # BRE regex of file contents to identify a test script.
  1089. _test_script_regex ?= \<init\.sh\>
  1090. # In tests, use "compare expected actual", not the reverse.
  1091. sc_prohibit_reversed_compare_failure:
  1092. @prohibit='\<compare [^ ]+ ([^ ]*exp|/dev/null)' \
  1093. containing='$(_test_script_regex)' \
  1094. halt='reversed compare arguments' \
  1095. $(_sc_search_regexp)
  1096. # #if HAVE_... will evaluate to false for any non numeric string.
  1097. # That would be flagged by using -Wundef, however gnulib currently
  1098. # tests many undefined macros, and so we can't enable that option.
  1099. # So at least preclude common boolean strings as macro values.
  1100. sc_Wundef_boolean:
  1101. @prohibit='^#define.*(yes|no|true|false)$$' \
  1102. in_files='$(CONFIG_INCLUDE)' \
  1103. halt='Use 0 or 1 for macro values' \
  1104. $(_sc_search_regexp)
  1105. # Even if you use pathmax.h to guarantee that PATH_MAX is defined, it might
  1106. # not be constant, or might overflow a stack. In general, use PATH_MAX as
  1107. # a limit, not an array or alloca size.
  1108. sc_prohibit_path_max_allocation:
  1109. @prohibit='(\balloca *\([^)]*|\[[^]]*)\bPATH_MAX' \
  1110. halt='Avoid stack allocations of size PATH_MAX' \
  1111. $(_sc_search_regexp)
  1112. sc_vulnerable_makefile_CVE-2009-4029:
  1113. @prohibit='perm -777 -exec chmod a\+rwx|chmod 777 \$$\(distdir\)' \
  1114. in_files='(^|/)Makefile\.in$$' \
  1115. halt=$$(printf '%s\n' \
  1116. 'the above files are vulnerable; beware of running' \
  1117. ' "make dist*" rules, and upgrade to fixed automake' \
  1118. ' see http://bugzilla.redhat.com/542609 for details') \
  1119. $(_sc_search_regexp)
  1120. sc_vulnerable_makefile_CVE-2012-3386:
  1121. @prohibit='chmod a\+w \$$\(distdir\)' \
  1122. in_files='(^|/)Makefile\.in$$' \
  1123. halt=$$(printf '%s\n' \
  1124. 'the above files are vulnerable; beware of running' \
  1125. ' "make distcheck", and upgrade to fixed automake' \
  1126. ' see http://bugzilla.redhat.com/CVE-2012-3386 for details') \
  1127. $(_sc_search_regexp)
  1128. vc-diff-check:
  1129. $(AM_V_GEN)(unset CDPATH; cd $(srcdir) && $(VC) diff) > vc-diffs || :
  1130. $(AM_V_at)if test -s vc-diffs; then \
  1131. cat vc-diffs; \
  1132. echo "Some files are locally modified:" 1>&2; \
  1133. exit 1; \
  1134. else \
  1135. rm vc-diffs; \
  1136. fi
  1137. rel-files = $(DIST_ARCHIVES)
  1138. gnulib_dir ?= $(srcdir)/gnulib
  1139. gnulib-version = $$(cd $(gnulib_dir) && git describe)
  1140. bootstrap-tools ?= autoconf,automake,gnulib
  1141. # If it's not already specified, derive the GPG key ID from
  1142. # the signed tag we've just applied to mark this release.
  1143. gpg_key_ID ?= \
  1144. $$(cd $(srcdir) \
  1145. && git cat-file tag v$(VERSION) \
  1146. | gpgv --status-fd 1 --keyring /dev/null - - 2>/dev/null \
  1147. | awk '/^\[GNUPG:\] ERRSIG / {print $$3; exit}')
  1148. translation_project_ ?= coordinator@translationproject.org
  1149. # Make info-gnu the default only for a stable release.
  1150. announcement_Cc_stable = $(translation_project_), $(PACKAGE_BUGREPORT)
  1151. announcement_mail_headers_stable = \
  1152. To: info-gnu@gnu.org \
  1153. Cc: $(announcement_Cc_) \
  1154. Mail-Followup-To: $(PACKAGE_BUGREPORT)
  1155. announcement_Cc_alpha = $(translation_project_)
  1156. announcement_mail_headers_alpha = \
  1157. To: $(PACKAGE_BUGREPORT) \
  1158. Cc: $(announcement_Cc_)
  1159. announcement_mail_Cc_beta = $(announcement_mail_Cc_alpha)
  1160. announcement_mail_headers_beta = $(announcement_mail_headers_alpha)
  1161. announcement_mail_Cc_ ?= $(announcement_mail_Cc_$(release-type))
  1162. announcement_mail_headers_ ?= $(announcement_mail_headers_$(release-type))
  1163. announcement: NEWS ChangeLog $(rel-files)
  1164. # Not $(AM_V_GEN) since the output of this command serves as
  1165. # annoucement message: it would start with " GEN announcement".
  1166. $(AM_V_at)$(srcdir)/$(_build-aux)/announce-gen \
  1167. --mail-headers='$(announcement_mail_headers_)' \
  1168. --release-type=$(release-type) \
  1169. --package=$(PACKAGE) \
  1170. --prev=$(PREV_VERSION) \
  1171. --curr=$(VERSION) \
  1172. --gpg-key-id=$(gpg_key_ID) \
  1173. --srcdir=$(srcdir) \
  1174. --news=$(srcdir)/NEWS \
  1175. --bootstrap-tools=$(bootstrap-tools) \
  1176. $$(case ,$(bootstrap-tools), in (*,gnulib,*) \
  1177. echo --gnulib-version=$(gnulib-version);; esac) \
  1178. --no-print-checksums \
  1179. $(addprefix --url-dir=, $(url_dir_list))
  1180. .PHONY: release-commit
  1181. release-commit:
  1182. $(AM_V_GEN)cd $(srcdir) \
  1183. && $(_build-aux)/do-release-commit-and-tag \
  1184. -C $(abs_builddir) $(RELEASE)
  1185. ## ---------------- ##
  1186. ## Updating files. ##
  1187. ## ---------------- ##
  1188. ftp-gnu = ftp://ftp.gnu.org/gnu
  1189. www-gnu = http://www.gnu.org
  1190. upload_dest_dir_ ?= $(PACKAGE)
  1191. upload_command = \
  1192. $(srcdir)/$(_build-aux)/gnupload $(GNUPLOADFLAGS) \
  1193. --to $(gnu_rel_host):$(upload_dest_dir_) \
  1194. $(rel-files)
  1195. emit_upload_commands:
  1196. @echo =====================================
  1197. @echo =====================================
  1198. @echo '$(upload_command)'
  1199. @echo '# send the ~/announce-$(my_distdir) e-mail'
  1200. @echo =====================================
  1201. @echo =====================================
  1202. .PHONY: upload
  1203. upload:
  1204. $(AM_V_GEN)$(upload_command)
  1205. define emit-commit-log
  1206. printf '%s\n' 'maint: post-release administrivia' '' \
  1207. '* NEWS: Add header line for next release.' \
  1208. '* .prev-version: Record previous version.' \
  1209. '* cfg.mk (old_NEWS_hash): Auto-update.'
  1210. endef
  1211. .PHONY: no-submodule-changes
  1212. no-submodule-changes:
  1213. $(AM_V_GEN)if test -d $(srcdir)/.git; then \
  1214. diff=$$(cd $(srcdir) && git submodule -q foreach \
  1215. git diff-index --name-only HEAD) \
  1216. || exit 1; \
  1217. case $$diff in '') ;; \
  1218. *) echo '$(ME): submodule files are locally modified:'; \
  1219. echo "$$diff"; exit 1;; esac; \
  1220. else \
  1221. : ; \
  1222. fi
  1223. submodule-checks ?= no-submodule-changes public-submodule-commit
  1224. # Ensure that each sub-module commit we're using is public.
  1225. # Without this, it is too easy to tag and release code that
  1226. # cannot be built from a fresh clone.
  1227. .PHONY: public-submodule-commit
  1228. public-submodule-commit:
  1229. $(AM_V_GEN)if test -d $(srcdir)/.git; then \
  1230. cd $(srcdir) && \
  1231. git submodule --quiet foreach test '$$(git rev-parse $$sha1)' \
  1232. = '$$(git merge-base origin $$sha1)' \
  1233. || { echo '$(ME): found non-public submodule commit' >&2; \
  1234. exit 1; }; \
  1235. else \
  1236. : ; \
  1237. fi
  1238. # This rule has a high enough utility/cost ratio that it should be a
  1239. # dependent of "check" by default. However, some of us do occasionally
  1240. # commit a temporary change that deliberately points to a non-public
  1241. # submodule commit, and want to be able to use rules like "make check".
  1242. # In that case, run e.g., "make check gl_public_submodule_commit="
  1243. # to disable this test.
  1244. gl_public_submodule_commit ?= public-submodule-commit
  1245. check: $(gl_public_submodule_commit)
  1246. .PHONY: alpha beta stable release
  1247. ALL_RECURSIVE_TARGETS += alpha beta stable
  1248. alpha beta stable: $(local-check) writable-files $(submodule-checks)
  1249. $(AM_V_GEN)test $@ = stable \
  1250. && { echo $(VERSION) | grep -E '^[0-9]+(\.[0-9]+)+$$' \
  1251. || { echo "invalid version string: $(VERSION)" 1>&2; exit 1;};}\
  1252. || :
  1253. $(AM_V_at)$(MAKE) vc-diff-check
  1254. $(AM_V_at)$(MAKE) news-check
  1255. $(AM_V_at)$(MAKE) distcheck
  1256. $(AM_V_at)$(MAKE) dist
  1257. $(AM_V_at)$(MAKE) $(release-prep-hook) RELEASE_TYPE=$@
  1258. $(AM_V_at)$(MAKE) -s emit_upload_commands RELEASE_TYPE=$@
  1259. release:
  1260. $(AM_V_GEN)$(MAKE) $(release-type)
  1261. # Override this in cfg.mk if you follow different procedures.
  1262. release-prep-hook ?= release-prep
  1263. gl_noteworthy_news_ = * Noteworthy changes in release ?.? (????-??-??) [?]
  1264. .PHONY: release-prep
  1265. release-prep:
  1266. $(AM_V_GEN)$(MAKE) --no-print-directory -s announcement \
  1267. > ~/announce-$(my_distdir)
  1268. $(AM_V_at)if test -d $(release_archive_dir); then \
  1269. ln $(rel-files) $(release_archive_dir); \
  1270. chmod a-w $(rel-files); \
  1271. fi
  1272. $(AM_V_at)echo $(VERSION) > $(prev_version_file)
  1273. $(AM_V_at)$(MAKE) update-NEWS-hash
  1274. $(AM_V_at)perl -pi \
  1275. -e '$$. == 3 and print "$(gl_noteworthy_news_)\n\n\n"' \
  1276. $(srcdir)/NEWS
  1277. $(AM_V_at)msg=$$($(emit-commit-log)) || exit 1; \
  1278. cd $(srcdir) && $(VC) commit -m "$$msg" -a
  1279. # Override this with e.g., -s $(srcdir)/some_other_name.texi
  1280. # if the default $(PACKAGE)-derived name doesn't apply.
  1281. gendocs_options_ ?=
  1282. .PHONY: web-manual
  1283. web-manual:
  1284. $(AM_V_GEN)test -z "$(manual_title)" \
  1285. && { echo define manual_title in cfg.mk 1>&2; exit 1; } || :
  1286. $(AM_V_at)cd '$(srcdir)/doc'; \
  1287. $(SHELL) ../$(_build-aux)/gendocs.sh $(gendocs_options_) \
  1288. -o '$(abs_builddir)/doc/manual' \
  1289. --email $(PACKAGE_BUGREPORT) $(PACKAGE) \
  1290. "$(PACKAGE_NAME) - $(manual_title)"
  1291. $(AM_V_at)echo " *** Upload the doc/manual directory to web-cvs."
  1292. .PHONY: web-manual-update
  1293. web-manual-update:
  1294. $(AM_V_GEN)cd $(srcdir) \
  1295. && $(_build-aux)/gnu-web-doc-update -C $(abs_builddir)
  1296. # Code Coverage
  1297. init-coverage:
  1298. $(MAKE) $(AM_MAKEFLAGS) clean
  1299. lcov --directory . --zerocounters
  1300. COVERAGE_CCOPTS ?= "-g --coverage"
  1301. COVERAGE_OUT ?= doc/coverage
  1302. build-coverage:
  1303. $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS)
  1304. $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS) check
  1305. mkdir -p $(COVERAGE_OUT)
  1306. lcov --directory . --output-file $(COVERAGE_OUT)/$(PACKAGE).info \
  1307. --capture
  1308. gen-coverage:
  1309. genhtml --output-directory $(COVERAGE_OUT) \
  1310. $(COVERAGE_OUT)/$(PACKAGE).info \
  1311. --highlight --frames --legend \
  1312. --title "$(PACKAGE_NAME)"
  1313. coverage: init-coverage build-coverage gen-coverage
  1314. # Some projects carry local adjustments for gnulib modules via patches in
  1315. # a gnulib patch directory whose default name is gl/ (defined in bootstrap
  1316. # via local_gl_dir=gl). Those patches become stale as the originals evolve
  1317. # in gnulib. Use this rule to refresh any stale patches. It applies each
  1318. # patch to the original in $(gnulib_dir) and uses the temporary result to
  1319. # generate a fuzz-free .diff file. If you customize the name of your local
  1320. # gnulib patch directory via bootstrap.conf, this rule detects that name.
  1321. # Run this from a non-VPATH (i.e., srcdir) build directory.
  1322. .PHONY: refresh-gnulib-patches
  1323. refresh-gnulib-patches:
  1324. gl=gl; \
  1325. if test -f bootstrap.conf; then \
  1326. t=$$(perl -lne '/^\s*local_gl_dir=(\S+)/ and $$d=$$1;' \
  1327. -e 'END{defined $$d and print $$d}' bootstrap.conf); \
  1328. test -n "$$t" && gl=$$t; \
  1329. fi; \
  1330. for diff in $$(cd $$gl; git ls-files | grep '\.diff$$'); do \
  1331. b=$$(printf %s "$$diff"|sed 's/\.diff$$//'); \
  1332. VERSION_CONTROL=none \
  1333. patch "$(gnulib_dir)/$$b" "$$gl/$$diff" || exit 1; \
  1334. ( cd $(gnulib_dir) || exit 1; \
  1335. git diff "$$b" > "../$$gl/$$diff"; \
  1336. git checkout $$b ) || exit 1; \
  1337. done
  1338. # Update gettext files.
  1339. PACKAGE ?= $(shell basename $(PWD))
  1340. PO_DOMAIN ?= $(PACKAGE)
  1341. POURL = http://translationproject.org/latest/$(PO_DOMAIN)/
  1342. PODIR ?= po
  1343. refresh-po:
  1344. rm -f $(PODIR)/*.po && \
  1345. echo "$(ME): getting translations into po (please ignore the robots.txt ERROR 404)..." && \
  1346. wget --no-verbose --directory-prefix $(PODIR) --no-directories --recursive --level 1 --accept .po --accept .po.1 $(POURL) && \
  1347. echo 'en@boldquot' > $(PODIR)/LINGUAS && \
  1348. echo 'en@quot' >> $(PODIR)/LINGUAS && \
  1349. ls $(PODIR)/*.po | sed 's/\.po//;s,$(PODIR)/,,' | sort >> $(PODIR)/LINGUAS
  1350. # Running indent once is not idempotent, but running it twice is.
  1351. INDENT_SOURCES ?= $(C_SOURCES)
  1352. .PHONY: indent
  1353. indent:
  1354. indent $(INDENT_SOURCES)
  1355. indent $(INDENT_SOURCES)
  1356. # If you want to set UPDATE_COPYRIGHT_* environment variables,
  1357. # put the assignments in this variable.
  1358. update-copyright-env ?=
  1359. # Run this rule once per year (usually early in January)
  1360. # to update all FSF copyright year lists in your project.
  1361. # If you have an additional project-specific rule,
  1362. # add it in cfg.mk along with a line 'update-copyright: prereq'.
  1363. # By default, exclude all variants of COPYING; you can also
  1364. # add exemptions (such as ChangeLog..* for rotated change logs)
  1365. # in the file .x-update-copyright.
  1366. .PHONY: update-copyright
  1367. update-copyright:
  1368. $(AM_V_GEN)grep -l -w Copyright \
  1369. $$(export VC_LIST_EXCEPT_DEFAULT=COPYING && $(VC_LIST_EXCEPT)) \
  1370. | $(update-copyright-env) xargs $(srcdir)/$(_build-aux)/$@
  1371. # This tight_scope test is skipped with a warning if $(_gl_TS_headers) is not
  1372. # overridden and $(_gl_TS_dir)/Makefile.am does not mention noinst_HEADERS.
  1373. # NOTE: to override any _gl_TS_* default value, you must
  1374. # define the variable(s) using "export" in cfg.mk.
  1375. _gl_TS_dir ?= src
  1376. ALL_RECURSIVE_TARGETS += sc_tight_scope
  1377. sc_tight_scope: tight-scope.mk
  1378. @fail=0; \
  1379. if ! grep '^ *export _gl_TS_headers *=' $(srcdir)/cfg.mk \
  1380. > /dev/null \
  1381. && ! grep -w noinst_HEADERS $(srcdir)/$(_gl_TS_dir)/Makefile.am \
  1382. > /dev/null 2>&1; then \
  1383. echo '$(ME): skipping $@'; \
  1384. else \
  1385. $(MAKE) -s -C $(_gl_TS_dir) \
  1386. -f Makefile \
  1387. -f $(abs_top_srcdir)/cfg.mk \
  1388. -f $(abs_top_builddir)/$< \
  1389. _gl_tight_scope \
  1390. || fail=1; \
  1391. fi; \
  1392. rm -f $<; \
  1393. exit $$fail
  1394. tight-scope.mk: $(ME)
  1395. @rm -f $@ $@-t
  1396. @perl -ne '/^# TS-start/.../^# TS-end/ and print' $(srcdir)/$(ME) > $@-t
  1397. @chmod a=r $@-t && mv $@-t $@
  1398. ifeq (a,b)
  1399. # TS-start
  1400. # Most functions should have static scope.
  1401. # Any that don't must be marked with 'extern', but 'main'
  1402. # and 'usage' are exceptions: they're always extern, but
  1403. # do not need to be marked. Symbols matching '__.*' are
  1404. # reserved by the compiler, so are automatically excluded below.
  1405. _gl_TS_unmarked_extern_functions ?= main usage
  1406. _gl_TS_function_match ?= /^(?:$(_gl_TS_extern)) +.*?(\S+) *\(/
  1407. # If your project uses a macro like "XTERN", then put
  1408. # the following in cfg.mk to override this default:
  1409. # export _gl_TS_extern = extern|XTERN
  1410. _gl_TS_extern ?= extern
  1411. # The second nm|grep checks for file-scope variables with 'extern' scope.
  1412. # Without gnulib's progname module, you might put program_name here.
  1413. # Symbols matching '__.*' are reserved by the compiler,
  1414. # so are automatically excluded below.
  1415. _gl_TS_unmarked_extern_vars ?=
  1416. # NOTE: the _match variables are perl expressions -- not mere regular
  1417. # expressions -- so that you can extend them to match other patterns
  1418. # and easily extract matched variable names.
  1419. # For example, if your project declares some global variables via
  1420. # a macro like this: GLOBAL(type, var_name, initializer), then you
  1421. # can override this definition to automatically extract those names:
  1422. # export _gl_TS_var_match = \
  1423. # /^(?:$(_gl_TS_extern)) .*?\**(\w+)(\[.*?\])?;/ || /\bGLOBAL\(.*?,\s*(.*?),/
  1424. _gl_TS_var_match ?= /^(?:$(_gl_TS_extern)) .*?(\w+)(\[.*?\])?;/
  1425. # The names of object files in (or relative to) $(_gl_TS_dir).
  1426. _gl_TS_obj_files ?= *.$(OBJEXT)
  1427. # Files in which to search for the one-line style extern declarations.
  1428. # $(_gl_TS_dir)-relative.
  1429. _gl_TS_headers ?= $(noinst_HEADERS)
  1430. _gl_TS_other_headers ?= *.h
  1431. .PHONY: _gl_tight_scope
  1432. _gl_tight_scope: $(bin_PROGRAMS)
  1433. t=exceptions-$$$$; \
  1434. trap 's=$$?; rm -f $$t; exit $$s' 0; \
  1435. for sig in 1 2 3 13 15; do \
  1436. eval "trap 'v=`expr $$sig + 128`; (exit $$v); exit $$v' $$sig"; \
  1437. done; \
  1438. src=`for f in $(SOURCES); do \
  1439. test -f $$f && d= || d=$(srcdir)/; echo $$d$$f; done`; \
  1440. hdr=`for f in $(_gl_TS_headers); do \
  1441. test -f $$f && d= || d=$(srcdir)/; echo $$d$$f; done`; \
  1442. ( printf '^%s$$\n' '__.*' $(_gl_TS_unmarked_extern_functions); \
  1443. grep -h -A1 '^extern .*[^;]$$' $$src \
  1444. | grep -vE '^(extern |--)' | sed 's/ .*//'; \
  1445. perl -lne \
  1446. '$(_gl_TS_function_match) and print "^$$1\$$"' $$hdr; \
  1447. ) | sort -u > $$t; \
  1448. nm -e $(_gl_TS_obj_files) | sed -n 's/.* T //p'|grep -Ev -f $$t \
  1449. && { echo the above functions should have static scope >&2; \
  1450. exit 1; } || : ; \
  1451. ( printf '^%s$$\n' '__.*' $(_gl_TS_unmarked_extern_vars); \
  1452. perl -lne '$(_gl_TS_var_match) and print "^$$1\$$"' \
  1453. $$hdr $(_gl_TS_other_headers) \
  1454. ) | sort -u > $$t; \
  1455. nm -e $(_gl_TS_obj_files) | sed -n 's/.* [BCDGRS] //p' \
  1456. | sort -u | grep -Ev -f $$t \
  1457. && { echo the above variables should have static scope >&2; \
  1458. exit 1; } || :
  1459. # TS-end
  1460. endif